<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入仓库/货架名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="编码" prop="code">
        <el-input v-model="queryParams.code" placeholder="请输入仓库/货架编码" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="openForm(undefined,false)"
                   v-hasPermi="['conf:base-warehouse:create']">新增
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="list"
      :stripe="true"
      :show-overflow-tooltip="true"
      v-if="refreshTable"
      row-key="id"
      :default-expand-all="isExpandAll"
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <el-table-column label="名称" align="left" prop="name"/>
      <el-table-column label="编码" align="center" prop="code"/>
      <el-table-column label="排序" align="center" prop="sort"/>
      <el-table-column label="状态" align="center" prop="status">
        <template v-slot="scope">
          <el-tag v-if="scope.row.status == '01'" type="success">启用</el-tag>
          <el-tag v-if="scope.row.status == '02'" type="danger">禁用</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="所属子公司" align="left" prop="corpNames"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button size="mini" type="text" icon="el-icon-plus" @click="openForm(scope.row.id,true)"
                     v-hasPermi="['conf:base-warehouse:update']">新增
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="openForm(scope.row.id,false)"
                     v-hasPermi="['conf:base-warehouse:update']">修改
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['conf:base-warehouse:delete']">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 对话框(添加 / 修改) -->
    <BaseWarehouseForm ref="formRef" @success="getList"/>
  </div>
</template>

<script>
import * as BaseWarehouseApi from '@/api/base/warehouse';
import BaseWarehouseForm from './BaseWarehouseForm.vue';

export default {
  name: "BaseWarehouse",
  components: {
    BaseWarehouseForm,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 仓库列表
      list: [],
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 选中行
      currentRow: {},
      // 查询参数
      queryParams: {
        parentId: null,
        name: null,
        code: null,
        status: null,
        remark: null,
        corpId: null,
        createTime: [],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    async getList() {
      try {
        this.loading = true;
        const res = await BaseWarehouseApi.getBaseWarehouseList(this.queryParams);
        this.list = this.handleTree(res.data, 'id', 'parentId',"children","0");
      } finally {
        this.loading = false;
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 添加/修改操作 */
    openForm(id,addChild) {
      this.$refs["formRef"].open(id,addChild);
    },
    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id;
      await this.$modal.confirm('是否确认删除仓库名称为"' + row.name + '"的数据项?')
      try {
        await BaseWarehouseApi.deleteBaseWarehouse(id);
        await this.getList();
        this.$modal.msgSuccess("删除成功");
      } catch {
      }
    },
    /** 导出按钮操作 */
    async handleExport() {
      await this.$modal.confirm('是否确认导出所有仓库数据项?');
      try {
        this.exportLoading = true;
        const data = await BaseWarehouseApi.exportBaseWarehouseExcel(this.queryParams);
        this.$download.excel(data, '仓库.xls');
      } catch {
      } finally {
        this.exportLoading = false;
      }
    },
    /** 展开/折叠操作 */
    toggleExpandAll() {
      this.refreshTable = false
      this.isExpandAll = !this.isExpandAll
      this.$nextTick(function () {
        this.refreshTable = true
      })
    }
  }
};
</script>
